
;***********************   AD7896*********************

;*   - 8,0 
;* ;
;* Main:          
;* InitLCD:        
;* Read_AD:       16   SPI  AD7896
;* ConvVolt:       
;* OutVolt:           
;* HexBCDm:	       - 
;* 

;*******************************************************************************

.nolist
.include "m8def.inc"
.list

;***** *****

.def	hexL = r11     ;    
.def	hexH = r12     ;    
  
;.def   EEdwr = r14    ;    EEPROM
;.def	EEdrd = r15    ;    EEPROM
.def	t1	 = r16     ;   
.def	t2	 = r17     ;   
;.def	t3   = r18     ;   
.def	prm1 =  r19    ;  
.def	Cnt = r20      ;    
.def	BCD0 = r21     ;  1  2  BCD - 
.def	BCD1 = r22     ;  3  4  BCD - 

.def	time = r24     ;   
             

;*****  *****

.equ  Ena  = 1	    ; Enable Impuls =  1  C
.equ  RS   = 0	    ; Register Select =  0  C
.equ  RW   = 2	    ; R/W =  2  C
.equ  BS   = 7	    ;   =  7  D

.equ  convst= 0	    ;  ,  0  B
.equ  busy =  1		;  ,  1  B
.equ  miso  = 4  	;   AD7896, 4  B
.equ  sck =   5		;    AD7896, 5  B 



.cseg

.org 0
	rjmp Initial

nop

Initial: ;     	
	
	ldi   t1,High(RamEnd) 
    out   sph,t1
    ldi   t1,Low(RamEnd)
    out   spl,t1	    ;  
    clr	t1 
	out	PORTD,t1        ; PORTD  
	ser	t1	            ;   DDRD	
	out	DDRD,t1	
    ldi   t1,0b00001000       
    out   PORTC,t1      ; RW,Ena,RS,= 0  
    ldi   t1,0b11110111	   
    out   DDRC,t1	    ; RW,Ena,RS=1
    ldi   t1,0b00110011       
    out   PORTB,t1      ;  
    ldi   t1,0b00100001	   
    out   DDRB,t1	    ; PB0-convst,PB1-busy,PB4-MISO,PB5-SCK

     
    ldi   t1,5	        ;  

	rcall InitLCD       ;  -
	rjmp Main

;***********************************************************************************
;   8-  ,   .
;***********************************************************************************
SendCom:	;   - 
cbi   PortC,RS	; Register Select = 
rcall LoadData
ret

SendDat:	;   -  
sbi   PortC,RS	; Register Select =  
rcall LoadData
ret

LoadData:	;   = 8 
out   PortD,prm1	;  /   D
sbi   PortC,Ena	;   
nop
nop	
nop
nop    	    ;     450 
cbi   PortC,Ena	;   
ret

WaitBusy:	;   -  
clr   t1
out   DDRD,t1	;  D = 
cbi   PortC,RS	; Register Select = 
sbi   PortC,RW	;  =   -
WB2:
sbi   PortC,Ena	;   
nop	
nop
nop	            ;  . 320   
in    t1,PinD	;  BF    
cbi   PortC,Ena	;   
nop
sbrc  t1,BS	;   ,  -  (BS=0)
rjmp  WB2
cbi   PortC,RW	;   =  -
ser   t1
out   DDRD,t1	;  D = 
ret

InitLCD:;   8-  

rcall wait5ms
rcall wait5ms
rcall wait5ms	;   20    
rcall wait5ms
ldi   prm1,$30	; $30:  , 8 
rcall SendCom	;    -
rcall wait50us	;   50 k
ldi   prm1,$30	; $30:  , 8 
rcall SendCom	;  
rcall wait50us	;   50 k
ldi   prm1,$30	; $30:  ,8  
rcall SendCom	;  
rcall wait50us	;   50 k
ldi   prm1,$38  ;  
rcall WaitBusy	;   -  
rcall SendCom	;    -
ldi   prm1,$08	; $08:  
rcall WaitBusy	;   -  
rcall SendCom	;  
ldi   prm1,$01	; $01:  
rcall WaitBusy	;   -  
rcall SendCom	;  
ldi   prm1,$06	; $06:    
rcall WaitBusy	;   -  
rcall SendCom	;  	
rcall wait5ms
ret
;***********************************************************************************
;    
;***********************************************************************************
Wait50us: ;    = 8 
ldi   time,130			;  
Wait51:
dec   time
brne  Wait51
ret

Wait8us: ;    = 8 
ldi   time,5			;  
Wait8:
dec   time
brne  Wait8
ret

Wait5ms: ;    = 8 
ldi   t2,100		  ;  
Wait53:
rcall wait50us
dec   t2
brne  Wait53
ret

Wait500: ;   500 
ldi   t1,0	    ;   
out   TCNT0,t1	;  T/C0
ldi   t1,1<<TOV0	;     TOV0
out   TIFR,t1	    ;   TOV0
ldi   t2,16 	    ; 16   
Wait:
in    t1,TIFR	    ;    TIFR
sbrs  t1,TOV0	    ;   ,   - 
rjmp  Wait	        ;   
ldi   t1,1<<TOV0	;     TOV0
out   TIFR,t1	    ;   TOV0 
dec   t2
brne  Wait	        ; 16  = 500 
ret

;***********************************************************************************

Main:    ;  
	
rcall Read_AD         ;  
rcall HexBCDm		  ;   BCD-
rcall ConvVolt        ;  
rcall OutVolt		  ;      
rcall Wait500         ; 
rcall Wait500
rjmp Main

Read_AD:;  16   SPI  AD7896

ldi   Cnt,16		;     16
cbi   PortB,convst  ; /convst =  
nop
sbi   PortB,convst
Busy1:
sbic  PINB,busy     ; busy =   
rjmp  Busy1
spi_loop:
lsl   hexL          ;   . 
rol   hexH		    ;   . 
sbi   PortB,sck		;   sck 
cbi   PortB,sck		;   sck
sbic  PINB,miso		;  MISO=0,  . 
inc hexL
dec   Cnt			;    1
brne  spi_loop		;  ,  Cnt   0
ret

OutVolt: ;      

ldi   prm1,$0C	 ;  , .   
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi prm1,$20	 ; 
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi prm1,$55	 ;  'U'
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi prm1,$3D	 ;  '='
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
lds prm1,SW3     ;  
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi prm1,$2C	 ;  ','
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
lds prm1,SW2     ;  
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
lds prm1,SW1     ;  
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
lds prm1,SW0     ;  
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$40	 ;  9-   
sbr prm1,1<<7
ldi prm1,$20	 ; 
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi prm1,$42	 ;  ''
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ret

ConvVolt:;   

mov t2,BCD1
andi BCD1,$F0    ;   
swap BCD1        ;  
ori BCD1,$30
sts SW3,BCD1     ;   4   
andi t2,$0F      ;   
ori t2,$30
sts SW2,t2       ;   3   
mov t2,BCD0
andi BCD0,$F0    ;   
swap BCD0        ;  
ori BCD0,$30
sts SW1,BCD0     ;   2   
andi t2,$0F      ;   
ori t2,$30
sts SW0,t2       ;   1   
ret

HexBCDm:	; xxxx (Hex) -> 0abcde (BCD)
rcall Div10m	; hexH:hexL / 10,  -  t1
mov   BCD0,t1	;  -  hexH:hexL, t1 =  1
rcall Div10m	;  =  2
swap  t1	;  2    
or    BCD0,t1	;   2  1  BCD0
rcall Div10m	;  =  3
mov   BCD1,t1	;  BCD1
rcall Div10m	;  =  4
swap  t1	;  4    
or    BCD1,t1	;   4  3  BCD1
ret

Div10m:	;  hexH:hexL  10,
	;    hexH:hexL,  -  t1
clr  t1
lsl  hexL
rol  hexH
rol  t1	    ;      10
lsl  hexL	;       
rol  hexH	;    0
rol  t1
lsl  hexL
rol  hexH
rol  t1
ldi  Cnt,13	;    13 s
Loop10m:
lsl  hexL	;     1 
rol  hexH
rol  t1	    ;   t1
subi t1,10	; :  > 10 ?
brlo HB1m	; ,  
inc  hexL   ;     1
rjmp HB2m
HB1m:
subi t1,-10	;   
HB2m:
dec  Cnt	;   
brne Loop10m; ,     
ret

.dseg


SW0: .byte 1   ; 0- 
SW1: .byte 1   ; 1- 
SW2: .byte 1   ; 2- 
SW3: .byte 1   ; 3- 


.EXIT

EEWrite:	;  "  EEPROM"

    sbic	EECR,EEWE	;  EEWE  . 0, 
	rjmp	EEWrite		;    
    ldi t1,0            ;      EEPROM -
	out	EEARH,t1 	    ;     
		                ;      EEPROM -
	out	EEARL,t3 	    ;     
	out	EEDR,EEdwr	    ;   -    
	sbi	EECR,EEMWE	    ;  EEMWE  
	sbi	EECR,EEWE	    ;  EEWE :  
				        ;     4- ,  
			        	;     2 
    ret

EERead:		;  " EEPROM"

    sbic	EECR, EEWE	;  EEWE  . 0, 
	rjmp	EERead		;    
    ldi t1,0            ;      EEPROM -
	out	EEARH,t1 	    ;     
	           	        ;     EEPROM -
	out	EEARL,t3	    ;      
	sbi	EECR, EERE	    ;   EERE    .
				        ;   4 ,  
				        ;   2 
	in	EEdrd, EEDR	    ;   
    ret	
