
;************************  ADS1110*********************

;*   - 8,0 
;* 
;* ;
;* Main:          
;* InitLCD:        
;* ReadADS1110:    ADS1110
;* WriteADS1110:   ADS1110
;* OutVolt:           
;* ConvVolt:       
;* CalcVolt:        
;* HexBCDm:	       BCD-
;* MUL42:         
;* DIV42:         
;* 

;*******************************************************************************

.nolist
.include "m8def.inc"
.list

;***** *****

.def	m0 = r1        ;     
.def	m1 = r2     
.def	m2 = r3      
.def	m3 = r4      
.def	m4 = r5      
.def	m5 = r6      
.def	m6 = r7
.def	m7 = r8

.def	hexL = r11     ;    
.def	hexH = r12     ;    

.def    EEdwr = r14    ;    EEPROM
.def	EEdrd = r15    ;    EEPROM
.def	t1	 = r16     ;   
.def	t2	 = r17     ;   
.def	t3   = r18     ;   
.def	prm1 =  r19    ;  
.def	Cnt = r20      ;    
.def	BCD0 = r21     ;  1  2  BCD - 
.def	BCD1 = r22     ;  3  4  BCD - 
.def	BCD2 = r23     ;  5  BCD - 
.def	time = r24     ;   
.def	ConFG = r25    ;   ADS1110
             

;*****  *****

.equ  Ena  = 1	    ; Enable Impuls =  1  C
.equ  RS   = 0	    ; Register Select =  0  C
.equ  RW   = 2	    ; R/W =  2  C
.equ  BS   = 7	    ;   =  7  D
.equ  AddrI2C  = 0b10010000 ;  ADS1110
.equ  SDA  = PC4    ;  TWI,SDA =  C /  4
.equ  SCL  = PC5    ;  TWI,SCL =  C /  5


.cseg

.org 0
	rjmp Initial

nop

Initial: ;     	
	
	ldi   t1,High(RamEnd) 
    out   sph,t1
    ldi   t1,Low(RamEnd)
    out   spl,t1	    ;  
    clr	t1 
	out	PORTD,t1        ; PORTD  
	ser	t1	            ;   DDRD	
	out	DDRD,t1	
    ldi   t1,0b00001000       
    out   PORTC,t1      ; RW,Ena,RS,= 0;PC5-SCL,PC4-SDA-  
    ldi   t1,0b11000111	   
    out   DDRC,t1	    ; RW,Ena,RS=1
    ldi   t1,0b00000000       
    out   PORTB,t1      ;  
    ldi   t1,0b00000000	   
    out   DDRB,t1	    ; 

ldi   t1,0 
out   TWBR,t1           ;     TWI (500kHz)
       
    ldi   t1,5	        ;  
    out   TCCR0,t1      ;  T/C2,  . = 1024

	rcall InitLCD       ;  -
    ldi ConFG,0b00001100; ST/DRDY,0,0,SC,DR1,DR0,PGA1,PGA0
	rcall WriteADS1110  ;     
	rjmp Main

;***********************************************************************************
;   8-  ,   .
;***********************************************************************************
SendCom:	;   - 
cbi   PortC,RS	; Register Select = 
rcall LoadData
ret

SendDat:	;   -  
sbi   PortC,RS	; Register Select =  
rcall LoadData
ret

LoadData:	;   = 8 
out   PortD,prm1	;  /   D
sbi   PortC,Ena	;   
nop
nop	
nop
nop    	    ;     450 
cbi   PortC,Ena	;   
ret

WaitBusy:	;   -  
clr   t1
out   DDRD,t1	;  D = 
cbi   PortC,RS	; Register Select = 
sbi   PortC,RW	;  =   -
WB2:
sbi   PortC,Ena	;   
nop	
nop
nop	            ;  . 320   
in    t1,PinD	;  BF    
cbi   PortC,Ena	;   
nop
sbrc  t1,BS	;   ,  -  (BS=0)
rjmp  WB2
cbi   PortC,RW	;   =  -
ser   t1
out   DDRD,t1	;  D = 
ret

InitLCD:;   8-  

rcall wait5ms
rcall wait5ms
rcall wait5ms	;   20    
rcall wait5ms
ldi   prm1,$30	; $30:  , 8 
rcall SendCom	;    -
rcall wait50us	;   50 k
ldi   prm1,$30	; $30:  , 8 
rcall SendCom	;  
rcall wait50us	;   50 k
ldi   prm1,$30	; $30:  ,8  
rcall SendCom	;  
rcall wait50us	;   50 k
ldi   prm1,$38  ;  
rcall WaitBusy	;   -  
rcall SendCom	;    -
ldi   prm1,$08	; $08:  
rcall WaitBusy	;   -  
rcall SendCom	;  
ldi   prm1,$01	; $01:  
rcall WaitBusy	;   -  
rcall SendCom	;  
ldi   prm1,$06	; $06:    
rcall WaitBusy	;   -  
rcall SendCom	;  	
rcall wait5ms
ret
;***********************************************************************************
;    
;***********************************************************************************
Wait50us: ;    = 8 
ldi   time,130			;  
Wait51:
dec   time
brne  Wait51
ret

Wait8us: ;    = 8 
ldi   time,5			;  
Wait88:
dec   time
brne  Wait88
ret

Wait5ms: ;    = 8 
ldi   t2,100		  ;  
Wait53:
rcall wait50us
dec   t2
brne  Wait53
ret

Wait500: ;   500 
ldi   t1,0	    ;   
out   TCNT0,t1	;  T/C0
ldi   t1,1<<TOV0	;     TOV0
out   TIFR,t1	    ;   TOV0
ldi   t2,16 	    ; 16   
Wait:
in    t1,TIFR	    ;    TIFR
sbrs  t1,TOV0	    ;   ,   - 
rjmp  Wait	        ;   
ldi   t1,1<<TOV0	;     TOV0
out   TIFR,t1	    ;   TOV0 
dec   t2
brne  Wait	        ; 16  = 500 
ret

;***********************************************************************************

Main:    ;  

rcall ReadADS1110     ;    

rcall CalcVolt		  ;   

rcall HexBCDm		  ;   BCD-

rcall ConvVolt        ;   
rcall OutVolt		  ;      
rcall Wait500
rcall Wait500
rjmp Main

ReadADS1110:  ;   ADS1110

ldi  t1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,t1  ;     
wait1:
in   t1,TWCR
sbrs t1,TWINT
rjmp wait1

ldi  t1,AddrI2C+1     ;   TWDR   
out  TWDR,t1
ldi  t1, (1<<TWINT) | (1<<TWEN)
out  TWCR,t1
wait2:
in   t1,TWCR
sbrs t1,TWINT
rjmp wait2
                  ;     
ldi  t1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)
out  TWCR,t1
wait3:
in   t1,TWCR
sbrs t1,TWINT
rjmp wait3
in   m1,TWDR
                ;     
ldi  t1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)
out  TWCR,t1
wait4:
in   t1,TWCR
sbrs t1,TWINT
rjmp wait4
in   m0,TWDR
               ;   
ldi  t1, (1<<TWINT) | (1<<TWEN) |  (0<<TWEA)
out  TWCR,t1
wait5:
in   t1,TWCR
sbrs t1,TWINT
rjmp wait5
in   ConFG,TWDR

ldi  t1, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)  ; 
out  TWCR,t1

bst m1,7        ;      T
brtc Plus       ; ,   

neg m0          ;   1
com m1          ;   2

ldi t1,$2D      ;   (-)
sts SW5,t1
ret
PLUS:
ldi t1,$2B      ;   (+)
sts SW5,t1
ret

WriteADS1110:  ;   ADS1110

ldi  t1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,t1  ;     
wait6:
in   t1,TWCR
sbrs t1,TWINT
rjmp wait6

ldi  t1,AddrI2C         ;   
out  TWDR,t1
ldi  t1, (1<<TWINT) | (1<<TWEN)
out  TWCR,t1
wait7:
in   t1,TWCR
sbrs t1,TWINT
rjmp wait7

out  TWDR,ConFG  ;   TWDR 
ldi  t1, (1<<TWINT) | (1<<TWEN)
out  TWCR,t1
wait8:
in   t1,TWCR
sbrs t1,TWINT
rjmp wait8

ldi  t1, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)  ; 
out  TWCR,t1
ret

OutVolt: ;      

ldi   prm1,$0C	 ;  , .   
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
lds prm1,SW5     ;  
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi prm1,$55	 ;  'U'
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
lds prm1,SW4     ;  
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
lds prm1,SW3     ;  
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
lds prm1,SW2     ;  
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
lds prm1,SW1     ;  
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi prm1,$2C	 ;  ','
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
lds prm1,SW0     ;  	 ; 
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$40	 ;  9-   
sbr prm1,1<<7
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi prm1,$BC	 ;  ''
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi prm1,$42	 ;  ''
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ret

ConvVolt:;   

andi BCD2,$0F    ;   
ori BCD2,$30
sts SW4,BCD2     ;   5   
mov t2,BCD1
andi BCD1,$F0    ;   
swap BCD1        ;  
ori BCD1,$30
sts SW3,BCD1     ;   4   
andi t2,$0F      ;   
ori t2,$30
sts SW2,t2       ;   3   
mov t2,BCD0
andi BCD0,$F0    ;   
swap BCD0        ;  
ori BCD0,$30
sts SW1,BCD0     ;   2   
andi t2,$0F      ;   
ori t2,$30
sts SW0,t2       ;   1   
ret

HexBCDm:	; xxxx (Hex) -> 0abcde (BCD)
rcall Div10m	; hexH:hexL / 10,  -  t1
mov   BCD0,t1	;  -  hexH:hexL, t1 =  1
rcall Div10m	;  =  2
swap  t1	;  2    
or    BCD0,t1	;   2  1  BCD0
rcall Div10m	;  =  3
mov   BCD1,t1	;  BCD1
rcall Div10m	;  =  4
swap  t1	;  4    
or    BCD1,t1	;   4  3  BCD1
mov   BCD2,hexL	;  5 -  BCD2,   = 0
ret

Div10m:	;  hexH:hexL  10,
	;    hexH:hexL,  -  t1
clr  t1
lsl  hexL
rol  hexH
rol  t1	    ;      10
lsl  hexL	;       
rol  hexH	;    0
rol  t1
lsl  hexL
rol  hexH
rol  t1
ldi  Cnt,13	;    13 s
Loop10m:
lsl  hexL	;     1 
rol  hexH
rol  t1	    ;   t1
subi t1,10	; :  > 10 ?
brlo HB1m	; ,  
inc  hexL   ;     1
rjmp HB2m
HB1m:
subi t1,-10	;   
HB2m:
dec  Cnt	;   
brne Loop10m; ,     
ret

CalcVolt:;    

ldi t1,$71          ;  625=$0271 0C35
mov m2,t1
ldi t1,$02
mov m3,t1
ldi t1,0            ;        
mov m4,t1
mov m5,t1
mov m6,t1
mov m7,t1

rcall MUL42

ldi t1,$E8          ;    1000=$03E8 2710
mov m0,t1                
ldi t1,$03
mov m1,t1

rcall DIV42

mov hexL,m4			;      BCD-
mov hexH,m5
ret

MUL42:          ;  
ldi  t1,0x10
MUL1:               ; , m3:m2 * m1:m0
mov  t2,m2          ;   m7:m6:m5:m4
ror  t2           
brcc  MUL2        
mov  t2,m6
add  t2,m0
mov  m6,t2
mov  t2,m7
adc  t2,m1
mov  m7,t2
MUL2:
mov  t2,m7
ror  t2
mov  m7,t2
mov  t2,m6
ror  t2
mov  m6,t2
mov  t2,m5
ror  t2
mov  m5,t2
mov  t2,m4
ror  t2
mov  m4,t2
mov  t2,m3
ror  t2
mov  m3,t2
mov  t2,m2
ror  t2
mov  m2,t2
dec  t1
cpi  t1,0
brne MUL1
ret

DIV42:        ;  
ldi  t1,0x10
DCLK42:             ;   m7:m6:m5:m4
clc                 ;   m1:m0
mov  t2,m4          ;   m5:m4
rol  t2
mov  m4,t2
mov  t2,m5
rol  t2
mov  m5,t2
mov  t2,m6
rol  t2
mov  m6,t2
mov  t2,m7
rol  t2
mov  m7,t2
in   Cnt,SREG
push Cnt
PER1:
clc
mov  t2,m6
sbc  t2,m0
mov  m6,t2
mov  t2,m7
sbc  t2,m1
mov  m7,t2
brcs PER2
pop  Cnt
out  SREG,Cnt
PER3:
inc m4
rjmp PER4
PER2:
pop  Cnt
out  SREG,Cnt
brcs PER3
mov  t2,m6
add  t2,m0
mov  m6,t2
mov  t2,m7
adc  t2,m1
mov  m7,t2
PER4:
dec  t1
cpi  t1,0
brne DCLK42
ret


.dseg


SW0: .byte 1   ; 0- 
SW1: .byte 1   ; 1- 
SW2: .byte 1   ; 2- 
SW3: .byte 1   ; 3- 
SW4: .byte 1   ; 4- 
SW5: .byte 1   ; 

.EXIT

EEWrite:	;  "  EEPROM"

    sbic	EECR,EEWE	;  EEWE  . 0, 
	rjmp	EEWrite		;    
    ldi t1,0            ;      EEPROM -
	out	EEARH,t1 	    ;     
		                ;      EEPROM -
	out	EEARL,t3 	    ;     
	out	EEDR,EEdwr	    ;   -    
	sbi	EECR,EEMWE	    ;  EEMWE  
	sbi	EECR,EEWE	    ;  EEWE :  
				        ;     4- ,  
			        	;     2 
    ret

EERead:		;  " EEPROM"

    sbic	EECR, EEWE	;  EEWE  . 0, 
	rjmp	EERead		;    
    ldi t1,0            ;      EEPROM -
	out	EEARH,t1 	    ;     
	           	        ;     EEPROM -
	out	EEARL,t3	    ;      
	sbi	EECR, EERE	    ;   EERE    .
				        ;   4 ,  
				        ;   2 
	in	EEdrd, EEDR	    ;   
   	ret	

;ldi t3,1
;mov EEdwr,m1  
;rcall EEwrite

;ldi t3,2
;mov EEdwr,m0
;rcall EEwrite

;ldi t3,3
;mov EEdwr,ConFG
;rcall EEwrite





