
;************************   MCP3201*********************

;*   - 8,0 
;* ;
;* Main:          
;* InitLCD:        
;* ReadADC:          ADC
;* Input_SPI:	 16   SPI, CPHA=1,CPOL=1,   MCP3201
;* OutVolt:           
;* ConvVolt:       
;* HexBCDm:	        BCD-
;* CalcVolt:        
;* MUL42:         
;* DIV42:         
;* 
;* 

;*******************************************************************************

.nolist
.include "m8def.inc"
.list

;***** *****

.def	m0 = r1        ;     
.def	m1 = r2     
.def	m2 = r3      
.def	m3 = r4      
.def	m4 = r5      
.def	m5 = r6      
.def	m6 = r7
.def	m7 = r8

.def	hexL = r11     ;    
.def	hexH = r12     ;    
.def    cpyL = r13     ;      
.def   EEdwr = r14    ;    EEPROM
.def	EEdrd = r15    ;    EEPROM
.def	t1	 = r16     ;   
.def	t2	 = r17     ;   
.def	t3   = r18     ;   
.def	prm1 =  r19    ;  
.def	Cnt = r20      ;    
.def	BCD0 = r21     ;  1  2  BCD - 
.def	BCD1 = r22     ;  3  4  BCD - 

.def	time = r24     ;   

             

;*****  *****

.equ  Ena  = 1	    ; Enable Impuls =  1  C
.equ  RS   = 0	    ; Register Select =  0  C
.equ  RW   = 2	    ; R/W =  2  C
.equ  BS   = 7	    ;   =  7  D
.equ  nss  = 2      ;  2  B

.cseg

.org 0
	rjmp Initial

nop

Initial: ;     	
	
	ldi   t1,High(RamEnd) 
    out   sph,t1
    ldi   t1,Low(RamEnd)
    out   spl,t1	    ;  
    clr	t1 
	out	PORTD,t1        ; PORTD  
	ser	t1	            ;   DDRD	
	out	DDRD,t1	
    ldi   t1,0b00001000       
    out   PORTC,t1      ; RW,Ena,RS,= 0  
    ldi   t1,0b11110111	   
    out   DDRC,t1	    ; RW,Ena,RS=1
    ldi   t1,0b00110100       
    out   PORTB,t1      ;  
    ldi   t1,0b00100100	   
    out   DDRB,t1	    ; PB2-nss,PB4-MISO,PB5-SCK
      
    ldi   t1,5	        ;  
    out   TCCR0,t1      ;  T/C2,  . = 1024

	rcall InitLCD       ;  -
	rjmp Main

;***********************************************************************************
;   8-  ,   .
;***********************************************************************************
SendCom:	;   - 
cbi   PortC,RS	; Register Select = 
rcall LoadData
ret

SendDat:	;   -  
sbi   PortC,RS	; Register Select =  
rcall LoadData
ret

LoadData:	;   = 8 
out   PortD,prm1	;  /   D
sbi   PortC,Ena	;   
nop
nop	
nop
nop    	    ;     450 
cbi   PortC,Ena	;   
ret

WaitBusy:	;   -  
clr   t1
out   DDRD,t1	;  D = 
cbi   PortC,RS	; Register Select = 
sbi   PortC,RW	;  =   -
WB2:
sbi   PortC,Ena	;   
nop	
nop
nop	            ;  . 320   
in    t1,PinD	;  BF    
cbi   PortC,Ena	;   
nop
sbrc  t1,BS	;   ,  -  (BS=0)
rjmp  WB2
cbi   PortC,RW	;   =  -
ser   t1
out   DDRD,t1	;  D = 
ret

InitLCD:;   8-  

rcall wait5ms
rcall wait5ms
rcall wait5ms	;   20    
rcall wait5ms
ldi   prm1,$30	; $30:  , 8 
rcall SendCom	;    -
rcall wait50us	;   50 k
ldi   prm1,$30	; $30:  , 8 
rcall SendCom	;  
rcall wait50us	;   50 k
ldi   prm1,$30	; $30:  ,8  
rcall SendCom	;  
rcall wait50us	;   50 k
ldi   prm1,$38  ;  
rcall WaitBusy	;   -  
rcall SendCom	;    -
ldi   prm1,$08	; $08:  
rcall WaitBusy	;   -  
rcall SendCom	;  
ldi   prm1,$01	; $01:  
rcall WaitBusy	;   -  
rcall SendCom	;  
ldi   prm1,$06	; $06:    
rcall WaitBusy	;   -  
rcall SendCom	;  	
rcall wait5ms
ret
;***********************************************************************************
;    
;***********************************************************************************
Wait50us: ;    = 8 
ldi   time,130			;  
Wait51:
dec   time
brne  Wait51
ret

Wait8us: ;    = 8 
ldi   time,5			;  
Wait8:
dec   time
brne  Wait8
ret

Wait5ms: ;    = 8 
ldi   t2,100		  ;  
Wait53:
rcall wait50us
dec   t2
brne  Wait53
ret

Wait500: ;   500 
ldi   t1,0	    ;   
out   TCNT0,t1	;  T/C0
ldi   t1,1<<TOV0	;     TOV0
out   TIFR,t1	    ;   TOV0
ldi   t2,16 	    ; 16   
Wait:
in    t1,TIFR	    ;    TIFR
sbrs  t1,TOV0	    ;   ,   - 
rjmp  Wait	        ;   
ldi   t1,1<<TOV0	;     TOV0
out   TIFR,t1	    ;   TOV0 
dec   t2
brne  Wait	        ; 16  = 500 
ret

;***********************************************************************************

Main:    ;  
	
rcall ReadADC         ;     ADC,  
rcall CalcVolt		  ;   
rcall HexBCDm		  ;   BCD-
rcall ConvVolt        ;   
rcall OutVolt		  ;     
rcall Wait500         ;  1 
rcall Wait500
rjmp Main

ReadADC:      ;     ADC

ldi   t1,1<<SPI2X	    ;    
out   SPSR,t1
ldi   t1,0b01011001	; SPIE=0,SPE=1,DORD=0,MSTR=1,CPOL=1,CPHA=0,SPR1=0,SPR0=1
out   SPCR,t1	        ; f(SCK)=f(.)/8,Fsck = 1,0 MHz
rcall Input_SPI
ret

Input_SPI:	; 16   SPI,  MCP3201

cbi   PortB,nss	     ; /CS =  (.0)
out SPDR,hexH        ;  
spi1:
sbis  SPSR,SPIF	;   ,   
rjmp  spi1
in   hexH,SPDR       ;   
out SPDR,hexL		 ;  
spi2:
sbis  SPSR,SPIF	;   ,   
rjmp  spi2;
in   hexL,SPDR       ;   
sbi   PortB,nss	     ; /CS =  (.1)
mov m0,hexL		     ;    
mov t1,hexH

andi t1,$1F          ;  3-     
mov m1,t1

ret

OutVolt: ;      

ldi   prm1,$0C	 ;  , .   
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi prm1,$20	 ; 
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi prm1,$55	 ;  'U'
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi prm1,$3D	 ;  '='
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
lds prm1,SW3     ;  
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi prm1,$2C	 ;  ','
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
lds prm1,SW2     ;  
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
lds prm1,SW1     ;  
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
lds prm1,SW0     ;  
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$40	 ;  9-   
sbr prm1,1<<7
ldi prm1,$20	 ; 
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi prm1,$42	 ;  ''
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ret

ConvVolt:;   

mov t2,BCD1
andi BCD1,$F0    ;   
swap BCD1        ;  
ori BCD1,$30
sts SW3,BCD1     ;   4   
andi t2,$0F      ;   
ori t2,$30
sts SW2,t2       ;   3   
mov t2,BCD0
andi BCD0,$F0    ;   
swap BCD0        ;  
ori BCD0,$30
sts SW1,BCD0     ;   2   
andi t2,$0F      ;   
ori t2,$30
sts SW0,t2       ;   1   
ret

HexBCDm:	; xxxx (Hex) -> 0abcde (BCD)
rcall Div10m	; hexH:hexL / 10,  -  t1
mov   BCD0,t1	;  -  hexH:hexL, t1 =  1
rcall Div10m	;  =  2
swap  t1	;  2    
or    BCD0,t1	;   2  1  BCD0
rcall Div10m	;  =  3
mov   BCD1,t1	;  BCD1
rcall Div10m	;  =  4
swap  t1	;  4    
or    BCD1,t1	;   4  3  BCD1
ret

Div10m:	;  hexH:hexL  10,
	;    hexH:hexL,  -  t1
clr  t1
lsl  hexL
rol  hexH
rol  t1	    ;      10
lsl  hexL	;       
rol  hexH	;    0
rol  t1
lsl  hexL
rol  hexH
rol  t1
ldi  Cnt,13	;    13 s
Loop10m:
lsl  hexL	;     1 
rol  hexH
rol  t1	    ;   t1
subi t1,10	; :  > 10 ?
brlo HB1m	; ,  
inc  hexL   ;     1
rjmp HB2m
HB1m:
subi t1,-10	;   
HB2m:
dec  Cnt	;   
brne Loop10m; ,     
ret

CalcVolt:;    

ldi t1,$9C          ;  7324=$1C9C
mov m2,t1
ldi t1,$1C
mov m3,t1
ldi t1,0            ;        
mov m4,t1
mov m5,t1
mov m6,t1
mov m7,t1

rcall MUL42

ldi t1,$10          ;    10000=$2710
mov m0,t1                
ldi t1,$27
mov m1,t1

rcall DIV42

mov hexL,m4			;       BCD-
mov hexH,m5
ret

MUL42:          ;  
ldi  t1,0x10
MUL1:               ; , m3:m2 * m1:m0
mov  t2,m2          ;   m7:m6:m5:m4
ror  t2           
brcc  MUL2        
mov  t2,m6
add  t2,m0
mov  m6,t2
mov  t2,m7
adc  t2,m1
mov  m7,t2
MUL2:
mov  t2,m7
ror  t2
mov  m7,t2
mov  t2,m6
ror  t2
mov  m6,t2
mov  t2,m5
ror  t2
mov  m5,t2
mov  t2,m4
ror  t2
mov  m4,t2
mov  t2,m3
ror  t2
mov  m3,t2
mov  t2,m2
ror  t2
mov  m2,t2
dec  t1
cpi  t1,0
brne MUL1
ret

DIV42:        ;  
ldi  t1,0x10
DCLK42:             ;   m7:m6:m5:m4
clc                 ;   m1:m0
mov  t2,m4          ;   m5:m4
rol  t2
mov  m4,t2
mov  t2,m5
rol  t2
mov  m5,t2
mov  t2,m6
rol  t2
mov  m6,t2
mov  t2,m7
rol  t2
mov  m7,t2
in   Cnt,SREG
push Cnt
PER1:
clc
mov  t2,m6
sbc  t2,m0
mov  m6,t2
mov  t2,m7
sbc  t2,m1
mov  m7,t2
brcs PER2
pop  Cnt
out  SREG,Cnt
PER3:
inc m4
rjmp PER4
PER2:
pop  Cnt
out  SREG,Cnt
brcs PER3
mov  t2,m6
add  t2,m0
mov  m6,t2
mov  t2,m7
adc  t2,m1
mov  m7,t2
PER4:
dec  t1
cpi  t1,0
brne DCLK42
ret

.dseg


SW0: .byte 1   ; 0- 
SW1: .byte 1   ; 1- 
SW2: .byte 1   ; 2- 
SW3: .byte 1   ; 3- 


.EXIT

EEWrite:	;  "  EEPROM"

    sbic	EECR,EEWE	;  EEWE  . 0, 
	rjmp	EEWrite		;    
    ldi t1,0            ;      EEPROM -
	out	EEARH,t1 	    ;     
		                ;      EEPROM -
	out	EEARL,t3 	    ;     
	out	EEDR,EEdwr	    ;   -    
	sbi	EECR,EEMWE	    ;  EEMWE  
	sbi	EECR,EEWE	    ;  EEWE :  
				        ;     4- ,  
			        	;     2 
   	ret

EERead:		;  " EEPROM"

    sbic	EECR, EEWE	;  EEWE  . 0, 
	rjmp	EERead		;    
    ldi t1,0            ;      EEPROM -
	out	EEARH,t1 	    ;     
	           	        ;     EEPROM -
	out	EEARL,t3	    ;      
	sbi	EECR, EERE	    ;   EERE    .
				        ;   4 ,  
				        ;   2 
	in	EEdrd, EEDR	    ;   
    ret	




